<script lang="ts">
import Vue from 'vue';
import { getPageMetadata } from '../../common/meta';
import { NextStep } from '../../components/common/index.vue';
import {
  Conduct,
  LightningHero,
  SpeakerSession,
  Section,
  Intro,
} from '../../components/events/index.vue';
import { CONTENT_TYPES } from '../../common/content-types';
import { getClient } from '~/plugins/contentful.js';
import {
  standardEventsDataHelper,
  EventData,
} from '~/services/events/events.service';

export default Vue.extend({
  components: {
    NextStep,
    Conduct,
    LightningHero,
    SpeakerSession,
    Intro,
    Section,
  },
  nuxtI18n: false,
  async asyncData() {
    const content: EventData = await getClient()
      .getEntries({
        content_type: CONTENT_TYPES.EVENT,
        include: 10,
        'sys.id': '55ut4OpTH7osA3cANGm6wm',
      })
      .then((query: any) => {
        const entryFields = query.items[0]?.fields;
        return standardEventsDataHelper(entryFields);
      })
      .catch(console.error);
    return { content };
  },
  head() {
    return getPageMetadata((this as any).content.metadata, this.$route.path);
  },
});
</script>

<template>
  <div>
    <LightningHero
      v-if="content.hero"
      :data="content.hero"
      :dark-mode="true"
      centered
    />
    <Intro v-if="content.description" :data="content.description" />
    <div v-if="content.booth">
      <Section
        v-for="(item, index) in content.booth"
        :key="index"
        :reverse="index % 2 !== 0"
        :data="item"
      />
    </div>
    <div v-if="content.sessions">
      <SpeakerSession
        v-for="(session, sessionIndex) in content.sessions"
        :key="sessionIndex"
        :data="session"
      />
    </div>
    <div v-if="content.footnote">
      <Conduct
        v-for="footnote in content.footnote"
        :key="footnote.header"
        :data="footnote"
      />
    </div>
    <NextStep :variant="content.nextSteps" />
  </div>
</template>
